// http://fr.openclassrooms.com/informatique/cours/programmez-avec-le-langage-c/les-structures-de-controle-4
#include <iostream>
#include <cmath>
// c.f. http://www.cplusplus.com/reference/cmath/

#include <stdlib.h> // pour random  : rand(...)
// c.f. http://www.cplusplus.com/reference/cstdlib/rand/

#include <iomanip>      // std::setiosflags, std::resetiosflags

// Opérateurs : c.f. http://www.cplusplus.com/doc/tutorial/operators/
//  +  -  *  /      %  = modulo
using namespace std;

int version_1()
//=============
// Le but est de convertir des nombres entiers relatifs
// de binaire en décimal et de décimal en binaire.
{
string strNb2 = "1"; // nombre en binaire, sous forme de chaine de caractères
int nNb10 = 0; // le nombre en base 10
int nPow2 = 1; // les puissances de 2.
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres entiers de et en binaire." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

cout << "Tapez le nombre en binaire : ";
cin >> strNb2;

nInd = strNb2.length();
nPow2 = 1; // les puissances de 2 suivant la position dans le nombre
nNb10 = 0;
while (nInd >= 0 ) {
  if (strNb2[nInd] == '1') {
     nNb10 += nPow2;
     nPow2 = nPow2 * 2;
     }

  if (strNb2[nInd] == '0') nPow2 = nPow2 * 2;
  // Si le chiffre binaire est différent de '0' et de '1', il est ignoré

  nInd--;
  }

cout << "Le nombre vaut en décimale : " << nNb10 << endl << endl;
return 0;
} // version_1()

int version_2()
//=============
// Le but est de convertir des nombres entiers relatifs
// de binaire en décimal et de décimal en binaire.
// Version qui permet de convertir plusieurs nombres.
{
string strNb2 = "1"; // nombre en binaire, sous forme de chaine de caractères
int nNb10 = 0; // le nombre en base 10
int nPow2 = 1; // les puissances de 2.
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres entiers de et en binaire." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le nombre en binaire : ";
   cin >> strNb2;
   if (strNb2.length() <= 1) return 0;

   nInd = strNb2.length();
   nPow2 = 1; // les puissances de 2 suivant la position dans le nombre
   nNb10 = 0;
   while (nInd >= 0 ) {
     if (strNb2[nInd] == '1') {
        nNb10 += nPow2;
        nPow2 = nPow2 * 2;
        }

     if (strNb2[nInd] == '0') nPow2 = nPow2 * 2;
     // Si le chiffre binaire est différent de '0' et de '1', il est ignoré

     nInd--;
     }

   cout << "Le nombre vaut en décimale : " << nNb10 << endl << endl;
   }

return 0;
} // version_2();

int version_3()
//=============
// Le but est de convertir des nombres entiers relatifs
// de binaire en décimal et de décimal en binaire.
// Traite plusieurs nombres et
// traites les espaces dans les données.
{
string strNb2 = "1"; // nombre en binaire, sous forme de chaine de caractères
char acNb2[256];
int nNb10 = 0; // le nombre en base 10
int nPow2 = 1; // les puissances de 2.
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres entiers de et en binaire." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le nombre en binaire : ";
   cin.getline(acNb2,256);  // met toute la ligne dans acNb2
   strNb2 = acNb2;          // convertir en string
   if (strNb2.length() <= 0) return 0;

   nInd = strNb2.length();
   nPow2 = 1; // les puissances de 2 suivant la position dans le nombre
   nNb10 = 0;
   while (nInd >= 0 ) {
     if (strNb2[nInd] == '1') {
        nNb10 += nPow2;
        nPow2 = nPow2 * 2;
        }

     if (strNb2[nInd] == '0') nPow2 = nPow2 * 2;
     // Si le chiffre binaire est différent de '0' et de '1', il est ignoré

     nInd--;
     }

   cout << "Le nombre vaut en décimale : " << nNb10 << endl << endl;
   }

return 0;
} // version_3

int version_4()
//=============
// Le but est de convertir des nombres entiers relatifs
// de binaire en décimal et de décimal en binaire.
// Traite plusieurs nombres et
// traites les espaces dans les données.
{
char acNb2[256]; // nombre en binaire, sous forme de chaine de caractères
int nNb10 = 0; // le nombre en base 10
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres entiers de et en binaire." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le nombre en binaire : ";
   cin.getline(acNb2,256);  // met toute la ligne dans acNb2

   if (acNb2[0] == 0) return 0; // car rien de tapé.

   nInd = 0;
   nNb10 = 0;
   while (acNb2[nInd] > 0 ) {
     if (acNb2[nInd] == '1') nNb10 = nNb10 * 2 + 1;
     if (acNb2[nInd] == '0') nNb10 = nNb10 * 2;
     // Si le chiffre binaire est différent de '0' et de '1', il est ignoré
     nInd++;
     }

   cout << "Le nombre vaut en décimale : " << nNb10 << endl << endl;
   }
} // version_4


int version_5()
//=============
// Le but est de convertir des nombres entiers relatifs
// de décimal en binaire.
// Traite plusieurs nombres et
// traites les espaces dans les données.
{
string strNb2 = ""; // nombre en binaire, sous forme de chaine de caractères
int nNb10 = 0; // le nombre en base 10
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres entiers de et en binaire." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le entier en base 10 : ";
   cin >> nNb10;

   if (nNb10 <= 0) return 0; // fin

// cout << setbase(16) << nNb10 << endl;  // bases permises : 8, 10, 16

   nInd = 0;
   strNb2 = "";
   while (nNb10 > 0 ) {
     if (nNb10 % 2 == 1) strNb2 = '1' + strNb2;
     else                strNb2 = '0' + strNb2;

     nNb10 = nNb10 / 2;
     }

   cout << "Le nombre vaut en binaire : " << strNb2 << endl << endl;
   }
} // version_5

int main()
//========
// Le but est de convertir des nombres entiers relatifs
// de binaire en décimal et de décimal en binaire.
{
//version_1();  // la version la plus simple
//version_2();
//version_3();  // la version qui effectue le plus de traitements
//version_4();
version_5();
}
